DECLARE SUB LoadDigits (F$)
DECLARE SUB Clock ()
DECLARE SUB PutLarge (Row!, Col!, n!)
DECLARE SUB PutSmall (Row!, Col!, n!)

' Digital Large Character Clock               (C)1990 Steve Gray
' =============================               V1.02 July 18,1990
' Started: July 16/90
' Updated: July 18/90
'
  DIM S$(6), L$(10)
  COMMON SHARED S$(), L$()
  CONST SH = 6, SW = 8, LH = 10, LW = 12

  ON ERROR GOTO ErrHandler
  F$ = "digits.dcc"
  IF COMMAND$ <> "" THEN
    F$ = COMMAND$
    IF RIGHT$(F$, 4) <> ".DCC" THEN F$ = F$ + ".DCC"
  END IF
  LoadDigits F$

  Clock
  END

ErrHandler:
  PRINT "Character definitions file not found."
  END

SUB Clock
  CLS
  LOCATE 10, 30: PRINT "[]"
  LOCATE 15, 30: PRINT "[]"

  DO
    t$ = TIME$: WHILE TIME$ = t$: WEND
    PutLarge 8, 4, VAL(MID$(t$, 1, 1))
    PutLarge 8, 17, VAL(MID$(t$, 2, 1))
    PutLarge 8, 34, VAL(MID$(t$, 4, 1))
    PutLarge 8, 47, VAL(MID$(t$, 5, 1))
    PutSmall 12, 62, VAL(MID$(t$, 7, 1))
    PutSmall 12, 70, VAL(MID$(t$, 8, 1))
  LOOP WHILE INKEY$ = ""
END SUB

SUB LoadDigits (F$)

  OPEN F$ FOR INPUT AS 1

'========== Read SMALL digits (0-9)
  FOR a = 1 TO SH
    DO: INPUT #1, a$: LOOP WHILE LEFT$(a$, 1) = ";"
    S$(a) = LEFT$(a$, 80)
  NEXT

'========== Read LARGE digits (0-4) then (5-9) (10 rows each)
  FOR b = 1 TO 2
    FOR a = 1 TO LH
      DO: INPUT #1, a$: LOOP WHILE LEFT$(a$, 1) = ";"
      L$(a) = L$(a) + LEFT$(a$, 60)
  NEXT a, b
  CLOSE #1
END SUB

SUB PutLarge (Row, Col, n)
    r = Row - 1
    FOR b = 1 TO LH
      LOCATE r + b, Col: PRINT MID$(L$(b), n * LW + 1, LW);
    NEXT b
END SUB

SUB PutSmall (Row, Col, n)
    r = Row - 1
    FOR b = 1 TO SH
      LOCATE r + b, Col: PRINT MID$(S$(b), n * SW + 1, SW);
    NEXT b
END SUB

